program logistic
  implicit none

  double precision :: da, a, amax,x
  integer :: n

  da = 0.001d0  ! a のステップ幅
  amax = 4.0d0  ! a の最大値

  open(1, file="logistic.dat")  ! 結果を出力するファイルを開く

  a = 1.0d0 ! aの初期値を1にセット
  do 
     print *, a  ! この文はなくても良いがいまどのaの計算が走っているのかを標準出力に表示
     x = 0.5d0   ! xの初期値を0.5とする(0<x<1であればなんでもよい)
     
     do n = 0, 600 ! 600回程度回す

        x = a * x * (1.0d0 - x) ! ロジスティック写像の式でx_iからx_{i+1}を計算

        if( n > 500) write(1,*) a, x  ! 500回を超えたところからaとxの値をファイルに出力する
        
     end do

     a = a + da             ! x_600くらいまで回したらaの値を0.001増やす
     if( a > amax ) exit ! aが4を超えたらdoループから抜けて計算を終了する
     
  end do

  close(1)                      !ファイルを閉じる
  
end program logistic
