program exercise18
  implicit none

  double precision :: x

  x = -10.0d0 ! xに初期値-10をセット

  open(1, file="sinx.dat", action="write") ! 結果を出力するファイルを開く

  do

     write(1,*) x, sin(x), sintaylor(x,1), sintaylor(x,3), sintaylor(x,5),  sintaylor(x,7), sintaylor(x,9),sintaylor(x,11) ! x, sin(x)とテーラー展開1,3,5,7,9,11次までの値を出力

     x = x + 0.01  ! xの値を0.01増やす

     if( x .gt. 10.0d0) exit ! xが10を超えたらdoループ終了
     
  end do

  close(1)
  
contains

 function sintaylor(x,n) !sin(x)をテーラー展開してn次まで計算する関数副プログラム
    integer, intent(in) :: n           ! 整数型引数nはテーラー展開の次数
    double precision, intent(in) :: x  ! 倍精度実数型引数xは関数の変数
    double precision :: sintaylor      ! 関数の返す倍精度実数型変数
    integer :: k, sgn
    
    sintaylor = 0.0d0  ! 初期値をセット

    sgn = 1 ! 符号
    
    do k = 1, n, 2        ! kがゼロからdoループを回して展開項を計算。奇数次のみ。

       sintaylor = sintaylor + sgn * x**k / factorial(k) ! k!は別の関数副プログラムを呼び出して計算

       sgn = sgn * (-1) !次の項は符号が変わるので-1をかける
       
    end do
    
    return  ! sintaylorの値を返して関数副プログラムを終了

  end function sintaylor  

  function factorial(n) ! 階乗の計算
    integer, intent(in) :: n  
    integer :: k
    double precision :: factorial 

    factorial = 0.0d0   
    if(n .lt. 0) return

    factorial = 1.0d0   
    if(n .eq. 0) return 

    do k = 1, n 
       factorial = factorial * dble(k) 
    end do

    return 
    
  end function factorial

end program exercise18
